-- Test add_campsite_type_carousel_slide
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(14);

set search_path to camper, public;

select has_function('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text']);
select function_lang_is('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'sql');
select function_returns('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'integer');
select isnt_definer('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text']);
select volatility_is('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'volatile');
select function_privs_are('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'add_campsite_type_carousel_slide', array['uuid', 'integer', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_carousel_i18n cascade;
truncate campsite_type_carousel cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (5, 1, 'text.txt', sha256('hello, world!'))
     , (6, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (10, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '<p>A</p>', 5, '[1, 7]', true)
     , (11, 1, '9b6370f7-f941-46f2-bc6e-de455675bd0a', 3, 'Type B', '<p>B</p>', 4, '[2, 6]', false)
;

insert into campsite_type_carousel (campsite_type_id, media_id, caption)
values (10, 4, 'A caption')
;

select lives_ok(
	$$ select add_campsite_type_carousel_slide('87452b88-b48f-48d3-bb6c-0296de64164e', 5, 'A caption') $$,
	'Should be able to add a carousel slide with a caption'
);

select lives_ok(
	$$ select add_campsite_type_carousel_slide('9b6370f7-f941-46f2-bc6e-de455675bd0a', 6, null) $$,
	'Should be able to add a carousel slide without caption'
);

select lives_ok(
	$$ select add_campsite_type_carousel_slide('87452b88-b48f-48d3-bb6c-0296de64164e', 4, 'New caption') $$,
	'Should be able to overwrite a slide with a new caption'
);

select bag_eq(
	$$ select campsite_type_id, media_id, caption from campsite_type_carousel $$,
	$$ values (10, 4, 'New caption')
	        , (10, 5, 'A caption')
	        , (11, 6, '')
	$$,
	'Should have all three slides'
);

select is_empty(
	$$ select * from campsite_type_carousel_i18n $$,
	'Should not have added any translation'
);

select *
from finish();

rollback;
